//+------------------------------------------------------------------+
//|                                                   SuperTrend.mq4 |
//|                                                                  |
//|                                      http://www.tradinformed.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Mark Ursell"
#property link      "http://www.tradinformed.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 FireBrick
#property indicator_color3 Green
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 2
#property indicator_style1 STYLE_DOT

// Constant definitions
#define INDICATOR_NAME "SuperTrend"


//---- input parameters
extern int    SuperTrendPeriod=20;      // SuperTrend ATR Period
extern double SuperTrendMultiplier=2.0; // SuperTrend Multiplier


//---- buffers
double STUp[];
double STDn[];
double STSuperTrend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


  int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, STSuperTrend);
   SetIndexLabel(0, "SuperTrend");
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, STDn);
   SetIndexLabel(1, "SuperTrend Down");
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, STUp);
   SetIndexLabel(2, "SuperTrend Up");
   IndicatorShortName(INDICATOR_NAME+"["+SuperTrendPeriod+";"+DoubleToStr(SuperTrendMultiplier,1)+"]");


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Last Counted Bar will Be Recounted                                         |
//+------------------------------------------------------------------+
int start()
  {
 int iNewBars, iCountedBars, i;
  double dAtr,dUpperLevel, dLowerLevel;  
  
  // Get unprocessed ticks
  iCountedBars=IndicatorCounted();
  if(iCountedBars < 0) return (-1); 
  if(iCountedBars>0) iCountedBars--;
  iNewBars=Bars-iCountedBars;
  for(i=iNewBars; i>=0; i--)
  
   
//---- Calculation
{
    dAtr = iATR(NULL, 0, SuperTrendPeriod, i);
    dUpperLevel=(High[i]+Low[i])/2+SuperTrendMultiplier*dAtr;
    dLowerLevel=(High[i]+Low[i])/2-SuperTrendMultiplier*dAtr;


//---- Set Indicator Levels
    if (Close[i]>STSuperTrend[i+1] && Close[i+1]<=STSuperTrend[i+1]) {
      STSuperTrend[i]=dLowerLevel;
    }
    else if (Close[i]<STSuperTrend[i+1] && Close[i+1]>=STSuperTrend[i+1]) {
      STSuperTrend[i]=dUpperLevel;
    }
    else if (STSuperTrend[i+1]<dLowerLevel)
        STSuperTrend[i]=dLowerLevel;
    else if (STSuperTrend[i+1]>dUpperLevel)
        STSuperTrend[i]=dUpperLevel;
    else
      STSuperTrend[i]=STSuperTrend[i+1];
//---- Draw SuperTrend lines
    STUp[i]=EMPTY_VALUE;
    STDn[i]=EMPTY_VALUE;
    if (Close[i]>STSuperTrend[i] || (Close[i]==STSuperTrend[i] && Close[i+1]>STSuperTrend[i+1])) 
      STUp[i]=STSuperTrend[i];
    else if (Close[i]<STSuperTrend[i] || (Close[i]==STSuperTrend[i] && Close[i+1]<STSuperTrend[i+1])) 
      STDn[i]=STSuperTrend[i];  
  }
  
  return(0);
}
//+------------------------------------------------------------------+